<?php
/** 
*
* @author Saanina (Abdullrahman Muhammad) http://phpbbarabia.com
*
* @package acp
* @version $Id: acp_do_sql.php 2009-01-10 07:56:43 GMT+3
* @copyright (c) 2009 phpbbarabia.com , partial copytights
* @license http://opensource.org/licenses/gpl-license.php GNU Public License 
*
*/

/**
* acp_do_sql
* Execute SQL queries
* @package acp
*/
class acp_do_sql
{
	var $u_action;

	function main($id, $mode)
	{
		global $config, $db, $user, $auth, $template;
		global $phpbb_root_path, $phpbb_admin_path, $phpEx;

		include($phpbb_root_path . 'includes/acp/info/acp_do_sql.' . $phpEx);
				
		$submit 		= (isset($_POST['submit'])) ? true : false;

		$error  = array();
		
		$version = new acp_do_sql_info();
		
		$do_sql_version = $version->module();
		$do_sql_version = $do_sql_version['version'];
		
		if (!isset($config['do_sql_version']))
		{
			$version->install();
		}
		else if (version_compare($config['do_sql_version'], $do_sql_version, '<'))
		{
			$version->update();
		}
			
		//universal seperator char 
		$seperate_char	=	';';
		
		
		//prevent error of dbal to triggers 
		//it's like make your kid stop crying :)
		$db->return_on_error = true;

		
		//get the query from the moon, sorry , i mean from the global variable
		$data = array(
			'qquery' => utf8_normalize_nfc(request_var('qquery', '', true)),
		);
		
		
		// Check and initialize some variables if needed
		if ($submit)
		{
	
			//no query data 
			if($data['qquery'] == '' && !$_FILES['sqlmodxml']['name'])
			{
				$error[] = $user->lang['NO_SQL_AND_MODX_ERROR'];
			}
			
			//modx but not xml !
			if ($_FILES['sqlmodxml']['name'] && $_FILES['sqlmodxml']['type'] != 'text/xml')
			{
				$error[] = $user->lang['WRONG_MODX_SQL_ERROR'];	
			}
			
			//modx queries
			if($_FILES['sqlmodxml']['name'])
			{ 
				$content_of_modx = $this->get_sql_from_mod_xml(file_get_contents($_FILES['sqlmodxml']['tmp_name'])); 
				if(!$content_of_modx)
				{
					$error[] = $user->lang['NO_SQL_IN_MODX_ERROR'];	
				}
				else
				{
					$data['qquery'] = $content_of_modx;
				}
			}
			
			//no error , it's like our life, sometime there are alot of mistakes, so we will never come to this point
			if (!sizeof($error))
			{
				
				//prepare the queries
				$data['qquery'] = str_replace('[phpbb_prefix]', $table_prefix, trim($data['qquery']));
				//$data['qquery'] = str_replace('phpbb_', $table_prefix, $data['qquery']);
				$data['qquery']	= str_replace($seperate_char . $seperate_char, $seperate_char, $data['qquery']);
				
				if(strlen($data['qquery']) == strrpos($data['qquery'], $seperate_char)+1)
				{
					$data['qquery']	= substr($data['qquery'], 0, strrpos($data['qquery'], $seperate_char));
				}
					
				//do it 
				//if more than query lets loop them 
				if(strpos($data['qquery'], $seperate_char) !== false)
				{
					$data['qquery']	.=	';';
					$do_sql = array();
					$manysql =	explode($seperate_char, $data['qquery']);
					
					foreach($manysql as $m)
					{
						if(empty($m))
						{
							continue;
						}
						
						$do_sql[] = $db->sql_query($m);
					}
				}
				else
				{
					$_POST['query']	.=	';';
					$do_sql = $db->sql_query($data['qquery']);
				}
				
				//lets now make erroes as normal error message ..  
				if(sizeof($db->sql_error_returned))
				{
					$error[] = $db->sql_error_sql;
					$error[] = implode('<br />', $db->sql_error_returned);
				}
				

	
				//no error at all
				if (!sizeof($error))
				{
					// Lets record it in the history .
					add_log('admin', 'LOG_DO_SQL');
					
					//END MESSAGE
					$message = array();
					$message[] = $user->lang['THE_QUERIES_SUCCESS_DSMOD'];
					$message[] = adm_back_link($this->u_action);
					
					trigger_error(implode('<br />', $message));
				}
			}
		}


		$template->assign_vars(array(
			'ERROR'				=> (sizeof($error)) ? implode('<br />', $error) : '',
			'QUERY'				=> $data['qquery'],
			'U_ACTION'			=> $this->u_action,
			
			)
		);


		$this->tpl_name = 'acp_do_sql';
		$this->page_title = 'ACP_DO_SQL';
	}
	
	function get_sql_from_mod_xml($xml)
	{
		preg_match("#<sql\>(.*?)<\/sql\>#is", $xml, $ma);
		return str_replace(array('<![CDATA[', ']]>'), '', $ma[1]);
	}
}

?>
