<?php
/**
*
* @author Saanina (Abdullrahman Muhammad) http://phpbbarabia.com
*
* @package acp
* @version $Id: acp_do_sql.php 31M 2007-08-05 01:18:59Z (local) $
* @copyright (c) 2009 phpbbarabia.com , partial copytights
* @license http://opensource.org/licenses/gpl-license.php GNU Public License 
*
*/

/**
* @package module_install
*/
class acp_do_sql_info
{
	var $u_action;
	
	function module()
	{		
		return array(
			'filename'	=> 'acp_do_sql',
			'title'		=> 'ACP_DO_SQL',
			'version'	=> '1.0.0',
			'modes'		=> array(
				'do_sql'	=> array(
					'title'		=> 'ACP_DO_SQL',
					'auth'		=> 'acl_a_board',
					'cat'		=> array('ACP_CAT_DATABASE'),
				),
			),
		);
	}

	function install()
	{
		global $phpbb_root_path, $phpEx, $db, $user;
		
		// Setup $auth_admin class so we can add permission options
		include($phpbb_root_path . 'includes/acp/auth.' . $phpEx);
		$auth_admin = new auth_admin();
		
		// Add permission for manage cvsdb
		$auth_admin->acl_add_option(array(
			'local'		=> array(),
			'global'	=> array('a_do_sql')
		));
		
		$module_data = $this->module();
		
		$module_basename = substr(strchr($module_data['filename'], '_'), 1);
		
		$sql = 'SELECT module_id
				FROM ' . MODULES_TABLE . "
				WHERE module_basename = '$module_basename'";
		$result = $db->sql_query($sql);
		$module_id = $db->sql_fetchfield('module_id');
		$db->sql_freeresult($result);
		
		$sql = 'UPDATE ' . MODULES_TABLE . " SET module_auth = 'acl_a_do_sql' WHERE module_id = $module_id";
		$db->sql_query($sql);
		
		set_config('do_sql_version', $module_data['version']);
		
		trigger_error(sprintf($user->lang['DO_SQL_MOD_UPDATED'], $module_data['version']) . adm_back_link($this->u_action));
	}

	function uninstall()
	{
	}
	
	function update()
	{
		global $user;
		
		$module_data = $this->module();
		
		set_config('do_sql_version', $module_data['version']);
		
		trigger_error(sprintf($user->lang['DO_SQL_MOD_UPDATED'], $module_data['version']) . adm_back_link($this->u_action));
	}
}

?>
